
#include <stdio.h>    /* Standard input/output definitions */
#include <stdint.h>   /* Standard types */
#include <string.h>   /* String function definitions */
#include <unistd.h>   /* UNIX standard function definitions */
#include <fcntl.h>    /* File control definitions */
#include <errno.h>    /* Error number definitions */
#include <termios.h>  /* POSIX terminal control definitions */
#include <sys/ioctl.h>
#include <getopt.h>
#include <sys/ioctl.h>
#include "stdio.h"


#include <iostream>
#include "CCoreMIDI.h"

#include <stdint.h>   /* Standard types */

#include <assert.h>
#include <pthread.h>



int serialport_init(const char* serialport, int baud);
int serialport_writebyte(int fd, uint8_t b);
int serialport_write(int fd, const char* str);
int serialport_read_until(int fd, char* buf, char until);



CCoreMIDI *_cCoreMIDI;
CCoreMIDIEndpointRef _fromMonomeSerial;
CCoreMIDIEndpointRef _toMonomeSerial; 
CCoreMIDIEndpointRef endpointRef;


/* our images*/
unsigned char tempBitmap [127][8];
int currentImage=0;


int n;
char c;

bool is_running=true;
int fd = 0;
int baudrate = B9600;  // default
char buf[256];
int rc;
int tem;
 

void sendToArduino(int data1)
{
	printf("sending note %d\n ",data1);
	
	 

		//sending command 3
		//sprintf(buf,"%c",data1); 
sprintf(buf,"%d",data1);
		rc = serialport_write(fd, buf);
		if(rc==-1)	 {	 printf("ERROR");	 };
		
	 		
   
	
}




void _handleMIDIMessage( int status, int data1,int  data2)
{
	
 //   printf("_handleMIDIMessage status %d\n",status);

    
	//if we get a 144 it means we get a note on, then we change current image
	if ( status == 0x90)
	{
     //   printf("_handleMIDIMessage %d\n",data1);

	    sendToArduino(data1);
		
	}
}


void  handleMIDIReceived(const MIDIPacketList *packetList, CCoreMIDIEndpointRef source)
{
	 //   printf("handleMIDIReceived\n");
	const MIDIPacket *packet = &packetList->packet[0];
	
	for (unsigned int i = 0; i < packetList->numPackets; i++) 
	{
		
		//	printf("numpackets %d %d\n",packetList->numPackets,i);
		
		unsigned char status, data1, data2, index;
		
		index = 0;
		
		for (unsigned int j = 0; j < packet->length; j++) 
		{
			unsigned char midiByte = packet->data[j];
			
			switch (index)
			{
				case 0:
					if (midiByte & 0x80) 
					{
						status = midiByte;
						index = 1;
					}
					
					break;
					
					case 1:
					if (midiByte & 0x80) 
					{
						status = midiByte;
						index = 1;
					}
					else 
					{
						data1 = midiByte;
						index = 2;
					}
					
					break;
					
					case 2:
					if (midiByte & 0x80) 
					{
						_handleMIDIMessage( status, data1, data2);
						
						status = midiByte;
						index = 1;
					}
					else
					{
						data2 = midiByte;
						_handleMIDIMessage( status, data1, data2);
						
						index = 0;
					}
					
					break;
			}
		}
		
		if (index != 0)
			_handleMIDIMessage( status, data1, data2);
		packet = MIDIPacketNext(packet);
	}
}


static void _ApplicationController_MIDIReceivedCallback(const MIDIPacketList *packetList, void *userData, CCoreMIDIEndpointRef source)
{
	handleMIDIReceived(packetList, source);
}


static void _ApplicationController_MIDISystemStateChangedCallback(const MIDINotification *message, void *userData)
{
	/* handleMIDISystemState(message);*/
	printf("handleMIDISystemState \n");
}


static void _ApplicationController_MIDIReceivedOnVirtualDestinationCallback(const MIDIPacketList *packetList, void *userData, CCoreMIDIEndpointRef source)
{
	handleMIDIReceived(packetList, source);
}

//fun to do at startup, so we know we are alive!
void blink()
{
	
	 
		sprintf(buf,"1");
		rc = serialport_write(fd, buf);
 		sprintf(buf,"2");
		rc = serialport_write(fd, buf);
	 
        sprintf(buf,"3");
		rc = serialport_write(fd, buf);
        sprintf(buf,"4");
		rc = serialport_write(fd, buf);
 
		
 
	
}


int main(int argc, char *argv[]) 
{
	string name = "WHAAA";
    string fromMonomeSerialString = "from SolenoidServer";
    string toMonomeSerialString = "to SolenoidServer";
	
	fd = serialport_init("/dev/tty.usbmodemfd121", baudrate);
	if(fd==-1) 
	{
		return -1;
	}
	
 	
    _cCoreMIDI = new CCoreMIDI(name);
    _fromMonomeSerial = _cCoreMIDI->createSource(fromMonomeSerialString);
    _toMonomeSerial = _cCoreMIDI->createDestination(toMonomeSerialString, _ApplicationController_MIDIReceivedOnVirtualDestinationCallback, NULL);
	
	_cCoreMIDI->registerForMIDISystemStateChangeNotifications(_ApplicationController_MIDISystemStateChangedCallback, NULL);
	
    if ((endpointRef = _fromMonomeSerial) == 0)
		printf("error\n");
	
	  
//	blink();	
    serialport_write(fd,"1234\n"); //Clear all leds

	tem = fcntl(0, F_GETFL, 0);
	fcntl (0, F_SETFL, (tem | O_NDELAY));
	
	 
	
	while (is_running)
	{
		//check keypress
		n = read(0, &c, 1);
		if (c =='q')  //if we dont quit properly the midi will stop responding and you have to let it timeout (24-48 hours or so) or reboot
		{
			is_running=false;
			
		}	
		usleep(1000); //hey man, we dont want to take all CPU, do we?
	
		 		
	}
 	fcntl(0, F_SETFL, tem);
	
	serialport_write(fd,"600"); //Clear all leds
	printf("Delete _cCoreMIDI \n");
	
	if (_cCoreMIDI != 0)
		delete _cCoreMIDI;
	
	
} // end main




int serialport_writebyte( int fd, uint8_t b)
{
    int n = write(fd,&b,1);
    if( n!=1)
        return -1;
    return 0;
}

int serialport_write(int fd, const char* str)
{
    int len = strlen(str);
    int n = write(fd, str, len);
    if( n!=len ) 
        return -1;
    return 0;
}

int serialport_read_until(int fd, char* buf, char until)
{
    char b[1];
    int i=0;
    do { 
        int n = read(fd, b, 1);  // read a char at a time
        if( n==-1) return -1;    // couldn't read
        if( n==0 ) {
            usleep( 10 * 1000 ); // wait 10 msec try again
            continue;
        }
        buf[i] = b[0]; i++;
    } while( b[0] != until );
	
    buf[i] = 0;  // null terminate the string
    return 0;
}

// takes the string name of the serial port (e.g. "/dev/tty.usbserial","COM1")
// and a baud rate (bps) and connects to that port at that speed and 8N1.
// opens the port in fully raw mode so you can send binary data.
// returns valid fd, or -1 on error
int serialport_init(const char* serialport, int baud)
{
    struct termios toptions;
    int fd;
    
    //fprintf(stderr,"init_serialport: opening port %s @ %d bps\n",
    //        serialport,baud);
	
    fd = open(serialport, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd == -1)  {
        printf("init_serialport: Unable to open port ");
        return -1;
    }
    
    if (tcgetattr(fd, &toptions) < 0) {
        printf("init_serialport: Couldn't get term attributes");
        return -1;
    }
    speed_t brate = baud; // let you override switch below if needed
    switch(baud) {
		case 4800:   brate=B4800;   break;
		case 9600:   brate=B9600;   break;
#ifdef B14400
		case 14400:  brate=B14400;  break;
#endif
		case 19200:  brate=B19200;  break;
#ifdef B28800
		case 28800:  brate=B28800;  break;
#endif
		case 38400:  brate=B38400;  break;
		case 57600:  brate=B57600;  break;
		case 115200: brate=B115200; break;
    }
    cfsetispeed(&toptions, brate);
    cfsetospeed(&toptions, brate);
	
    // 8N1
    toptions.c_cflag &= ~PARENB;
    toptions.c_cflag &= ~CSTOPB;
    toptions.c_cflag &= ~CSIZE;
    toptions.c_cflag |= CS8;
    // no flow control
    toptions.c_cflag &= ~CRTSCTS;
	
    toptions.c_cflag |= CREAD | CLOCAL;  // turn on READ & ignore ctrl lines
    toptions.c_iflag &= ~(IXON | IXOFF | IXANY); // turn off s/w flow ctrl
	
    toptions.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG); // make raw
    toptions.c_oflag &= ~OPOST; // make raw
	
    // see: http://unixwiz.net/techtips/termios-vmin-vtime.html
    toptions.c_cc[VMIN]  = 0;
    toptions.c_cc[VTIME] = 20;
    
    if( tcsetattr(fd, TCSANOW, &toptions) < 0) {
        printf("init_serialport: Couldn't set term attributes");
        return -1;
    }
	
    return fd;
}

